python中的报错问题(python中的错误)

python中的报错问题(python中的错误)1.NameError变量名错误

本文目录一览:

python新手常见的报错有哪些

1.NameError变量名错误

报错:

print a

Traceback (most recent call last):

File “stdin”, line 1, in module

NameError: name ‘a’ is not defined

解决方案:

先要给a赋值。才能使用它。在实际编写代码过程中,报NameError错误时,查看该变量是否赋值,或者是否有大小写不一致错误,或者说不小心将变量名写错了。

注:在Python中,无需显示变量声明语句,变量在第一次被赋值时自动声明。

a=1

print a

1

2.IndentationError代码缩进错误

代码:

a=1

b=2

if ab:

print a

报错:

IndentationError: expected an indented block

原因:

缩进有误,python的缩进非常严格,行首多个空格,少个空格都会报错。这是新手常犯的一个错误,由于不熟悉python编码规则。像def,class,if,for,while等代码块都需要缩进。

缩进为四个空格宽度,需要说明一点,不同的文本编辑器中制表符(tab键)代表的空格宽度不一,如果代码需要跨平台或跨编辑器读写,建议不要使用制表符。

解决方案:

a=1

b=2

if ab:

print a

3.AttributeError对象属性错误

报错:

import sys

sys.Path

Traceback (most recent call last):

File “stdin”, line 1, in module

AttributeError: ‘module’ object has no attribute ‘Path’

原因:

sys模块没有Path属性。

解决方案:

python对大小写敏感,Path和path代表不同的变量。将Path改为path即可。

sys.path

[”, ‘/usr/lib/python2.6/site-packages’]

python知识拓展:

使用dir函数查看某个模块的属性

dir(sys)

[‘__displayhook__’, ‘__doc__’, ‘__egginsert’, ‘__excepthook__’, ‘__name__’, ‘__package__’, ‘__plen’, ‘__stderr__’, ‘__stdin__’, ‘__stdout__’, ‘_clear_type_cache’, ‘_current_frames’, ‘_getframe’, ‘api_version’, ‘argv’, ‘builtin_module_names’, ‘byteorder’, ‘call_tracing’, ‘callstats’, ‘copyright’, ‘displayhook’, ‘dont_write_bytecode’, ‘exc_clear’, ‘exc_info’, ‘exc_type’, ‘excepthook’, ‘exec_prefix’, ‘executable’, ‘exit’, ‘flags’, ‘float_info’, ‘getcheckinterval’, ‘getdefaultencoding’, ‘getdlopenflags’, ‘getfilesystemencoding’, ‘getprofile’, ‘getrecursionlimit’, ‘getrefcount’, ‘getsizeof’, ‘gettrace’, ‘hexversion’, ‘maxint’, ‘maxsize’, ‘maxunicode’, ‘meta_path’, ‘modules’, ‘path’, ‘path_hooks’, ‘path_importer_cache’, ‘platform’, ‘prefix’, ‘ps1’, ‘ps2’, ‘py3kwarning’, ‘setcheckinterval’, ‘setdlopenflags’, ‘setprofile’, ‘setrecursionlimit’, ‘settrace’, ‘stderr’, ‘stdin’, ‘stdout’, ‘subversion’, ‘version’, ‘version_info’, ‘warnoptions’]

4.TypeError类型错误

4.1入参类型错误

代码:

t=(‘a’,’b’,’c’)

for i in range(t):

print a[i]

报错:

TypeError: range() integer end argument expected, got tuple.

原因:

range()函数期望的入参是整型(integer),但却给的入参为元组(tuple)

解决方案:

将入参元组t改为元组个数整型len(t)

将range(t)改为range(len(t))

Python 运行报错NameError出现原因,怎么解决

python程序,报错NameError: name XX is not defined 是没有声明造成的,需要在文件的前两行进行声明编码,声明方法为:

1、写一个python文件,文件中有中文字符,且未声明编码。

2、当程序文件中,存在中文字符时候,文件未声明编码格式就会出现报错信息:  File “encode.py”, line 1SyntaxError:

Non-ASCII character ‘\xe7’ in file encode.py on line 1, but no encoding

declared; see //..python…/dev/peps/pep-0263/ for details for details。

3、根据错误提示,在python官网得到如下帮助信息。

4、所以,按照帮助文档的提示以及例子,在Python文件中加入一个编码声明。

5、保存之后,再次运行,运行成功。

python中的报错问题(python中的错误)

python中,如图,为啥上面的报错,下面的两个都没问题?

第一部分:

因为上面的“x+=x”相当于在f2()函数中通过操作变量x得到变量x。

然而,f2()函数属于函数f1(),那么对于f2()函数来说,f1()函数中的变量也相当于f2()函数的全局变量,因此,f1()函数的变量x,就是相对于f2()函数的“全局变量”。

在Python中,您无法通过全局变量创建一个同名的局部变量。

也就是说,当你在f2()函数中想要定义一个局部变量x的时候,你使用了全局变量x,因为表达式左边为定义变量,右边为操作变量,这将导致解释器认为左边的x就是取值对象(先来后到),那么操作中的变量也会被认为局部变量中的x,然而局部变量中并没有x,那是你现在正在定义的,那么就会抛出使用前未定义的错误。

第二部分:

你将f2()的局部变量y定义为“x+1”。

表达式的右边是操作变量,变量x存在于全局变量(再次申明,是相对于函数f2()的全局变量),左边的y是你现在正在定义的局部变量,因此操作不矛盾。

第三部分

注意,你在f2()函数中并没有重新定义一个列表变量x,你只是重新定义了列表的第一个元素。

列表x存在于f2()的全局变量,你只是替换了其中的第一个元素,没有产生任何歧义。

如果你尝试以下代码,在f2()函数中通过x重新定义列表x:

def f1():

  def f2():

      x=x[0:3]#重新定义列表x

      return x[0]

  return f2()

x=[5,1,2,3]

i=f1()

print(i)

就会抛出使用前未定义的错误。

总的来说就是同名的全局和局部变量的操作,不能够冲突,否则Python解释器无法辨别和赋值变量。

python运行错误怎么办?

一、python的错误处理:

在程序运行的过程中,如果发生了错误,可以事先约定返回一个错误代码,这样,就可以知道是否有错以及出错的原因。

在操作系统提供的调用中,返回错误码非常常见。比如打开文件的函数open(),成功时返回文件的描述符(就是一个整数),出错时返回-1用错误码来表示是否出错十分不便,因为函数本身应该返回的正常结果和错误码混在一起,造成调用者必须大量的代码来判断是否出错:def foo():

r = somefunction()    if r == (-1):        return (-1)    return rdef bar():

r = foo()    if r == (-1):        print(“Error”)    else:        pass一旦出错,还要一级一级上报,直到某个函数可以处理该错误(比如,给用户输出一个错误信息)

所以,高级语言通常都内置了一套try…except…finally…的错误处理机制,python也不例外。try

让我们用一个例子来看看try的机制try:    print(“try….”)

r = 10 / 0    print(“result”, r)except ZeroDivisionError as e:    print(“except:”, e)finally:    print(“finally…”)print(“END….”)

当我们认为某些代码可能会出错时,就可以用try来运行这段代码,如果执行出错,则后续代码不会继续执行

而是直接跳转至错误处理代码,即except语句块

执行完except后,如果有finally语句块,则执行finally语句块,至此,执行完毕。

上面的代码在计算10 / 0时 会产生一个除法运算错误:try….except: division by zerofinally…

END….从输出可以看到,当错误发生时,后续语句print(“result:”, r)不会被执行,except由于捕获到ZeroDivisionError因此被执行。

最后,finally语句被执行。然后,程序继续按照流程往下走。

如果把除数0 变成2,则执行结果如下try….

result 5.0finally…

END….由于没有错误发生,所以except语句块不会被执行,但是finally如果有则一定会被执行,当然finally也可以没有

你还可以猜测,错误应该有很多种类,日过发生了不同类型的错误,应该由不同的except语句块处理。

没错,可以有多个except来捕获不同类型的错误:try:    print(“try…..”)

r = 10 / int(“a”)    print(“result:”, r)except ValueError as e:    print(“ValueError:”, e)except ZeroDivisionError as e:    print(“ZeroDivisionError:”, e)finally:    print(“finally…”)print(“END…”)

int()函数可能会抛出ValueError,所以我们用一个except捕获ValueError,用另一个except捕获ZeroDivisionError

此外,如果没有错误发生,可以再except语句块后面加一个else,当没有错误发生时,会自动执行else语句。try:    print(“try…”)

r = 10 / int(“2”)    print(“result:”, r)except ValueError as e:    print(“ValueError:”, e)except ZeroDivisionError as e:    print(“ZeroDivisionError:”, e)else:    print(“No error!”)finally:    print(“finally…”)print(“END”)

python的错误其实也是class,所有的错误类型都继承自BaseException,

所以在使用except时需要注意的是,它不但捕获该类型的错误,还把其子类也“一网打尽”。

比如:try:

foo()except ValueError as e:    print(“ValueError”)except UnicodeError as e:    print(“UnicodeError”)

第二个except永远也捕获不到UnicodeError, 因为UnicodeError是ValueError的子类

如果有,也是被第一个except给捕获了。

python所有的错误都是BaseException类派生的。

所有常见的错误类型和继承关系看这里:

使用try…exccept捕获错误还有一个巨大的好处,就是可以跨越多层调用,比如函数main()调用foo()

foo()调用bar(),结果bar()出错了,这时,只要main()捕获到了,就可以处理:def foo(s):    return 10 / int(s)def bar(s):    return foo(s) * 2def main():    try:

bar(“0”)    except Exception as e:        print(“Error:”, e)    finally:        print(“finally…”)

也就是说,不需要在每个可能出错的地方去捕获异常,只要在合适的层次去捕获就可以了。

这样一来,就大大减少了写 try…except…finally的麻烦。

二、调用堆栈

如果错误没有被捕获,他就会一直往上抛,最后被python解释器捕获,打印一个错误信息,然后程序退出。def foo(s):    return 10 / int(s)def bar(s):    return foo(s) * 2def main():

bar(“0”)

main()

执行结果为:

Traceback (most recent call last):

File “C:/Python36/test.py”, line 10, in module

main()

File “C:/Python36/test.py”, line 8, in main

bar(“0”)

File “C:/Python36/test.py”, line 5, in bar    return foo(s) * 2

File “C:/Python36/test.py”, line 2, in foo    return 10 / int(s)

ZeroDivisionError: division by zero

出错并不可怕,可怕的时不知道哪里出错了。解读错误信息时定位错误的关键。

我们从上往下可以看到整个错误的调用函数链。

错误第一行:

Traceback (most recent call last):

这告诉我们的是错误的跟踪信息。

File “C:/Python36/test.py”, line 10, in module main()

说明调用main()出错了,在代码文件test.py中第10行,但是原因是第8行:

File”C:/Python36/test.py”, line8, in main

bar(“0”)

调用bar(“0”)出错了,在代码文件test.py中第8行,但原因是第5行:

File”C:/Python36/test.py”, line5, in barreturn foo(s) * 2调用return foo(s) * 2时出错了,在test.py中第5行,但原因是第2行

File “C:/Python36/test.py”, line 2, in foo    return 10 / int(s)

ZeroDivisionError: division by zero

这时我们找到了源头,原来在第2行调用return 10 / int(s)出错了,错误为ZeroDivisionError

三、记录错误

如果不捕获错误,自然可以让python解释器来打印出错误堆栈,但是程序也被结束了。

既然我们能捕获错误,就可以把错误堆栈打印出来,然后分析错误原因,同时,让程序继续执行下去。

python内置的logging模块可以非常容易地记录错误信息:import loggingdef foo(s):    return 10 / int(s)def bar(s):    return foo(s) * 2def main():    try:

bar(“0”)    except Exception as e:

logging.exception(e)

main()print(“END”)

输出结果为:

ERROR:root:division by zero

Traceback (most recent call last):

File “C:/Python36/test.py”, line 12, in main

bar(“0”)

File “C:/Python36/test.py”, line 8, in bar    return foo(s) * 2

File “C:/Python36/test.py”, line 5, in foo    return 10 / int(s)

ZeroDivisionError: division by zero

END

同样是出错,但程序打印完错误信息后会继续执行,并正常退出。

通过配置,logging还可以把错误记录到日志文件里,方便事后排查。

四、抛出错误

因为错误是class,捕获一个错误就是捕获到该class的一个实例。

因此,错误并不是凭空产生的,而是有意创建并抛出的。

python的内置函数会抛出很多类型的错误,我们自己编写的函数也可以抛出错误。

如果要抛出错误,首先根据需要,可以定义一个错误的class,选择好继承关系,然后用raise语句抛出一个错误的实例:class FooError(ValueError):    passdef foo(s):

n =  int(s)    if n == 0:        raise FooError(“invalid value: %s” % s)    return 10 / n

foo(“0”)

输出结果:

Traceback (most recent call last):

File “C:/Python36/test.py”, line 10, in module

foo(“0”)

File “C:/Python36/test.py”, line 7, in foo    raise FooError(“invalid value: %s” % s)

FooError: invalid value: 0

只有在必要的时候才定义我们自己的错误类型。

如果可以选择python已有的内置错误类型(比如ValueError, TypeError),尽量使用python内置的错误类型。

最后,我们来看另一种错误处理方式:def foo(s):

n = int(s)    if n == 0:        raise ValueError(“invalid value: %s” % s)    return 10 / ndef bar():    try:

foo(“0”)    except ValueError as e:        print(“ValieError”)        raisebar()

在bar()函数中,我们明明已经捕获了错误,但是,打印一个ValueError之后

又通过raise语句抛出去了。这不是有病吗

其实,这种错误处理方式不但没病,而且相当常见。

捕获错误目的只是记录一下,便于或许追踪。

但是,由于当前函数不知道应该怎么处理该错误,所以,最恰当的方式是继续往上抛,让顶层调用者去处理。

好比一个员工处理不了一个问题时,就把问题一直往上抛,最终会抛给CEO去解决。

注意:raise语句如果不带参数,就会把当前错误原样抛出。

此外,在except中raise一个Error,还可以改写错误类型try:    10 / 0except ZeroDivisionError:    raise ValueError(“do not input zero!”)

输出结果:

Traceback (most recent call last):

File “C:/Python36/test.py”, line 4, in module    raise ValueError(“do not input zero!”)

ValueError: do not input zero!只要是合理的转换逻辑就可以,但是,绝不应该把一个IOError转成毫不相干的valueError.

总结:

python内置的 try…except…finally 用来处理错误十分方便。

出错时,会分析错误信息并定位错误发生的代码位置才是关键的。

程序也可以主动抛出错误,让调用者来处理相应的错误。

但是应该在文档中写清楚可能会抛出哪些错误,以及错误产生的原因。

Python中提示错误,什么情况?

这是因为整体复制过去运行而产生的错误;解决方案如下:

方法一:先将第一行复制,敲一下回车,再将剩下的部分复制过去,运行;

方法二:Ctrl+N,新建一个,这时直接将代码复制进来,就不会产生这个问题了;直接在IDLE中编译,是每行都要回车的。如果是单独的语句,只能是一行一行的编辑。、

例如:

python 报错

【现象】

很多Python初学者,在安装了最新版本的Python 3.x版本,比如Python 3.2之后,

去参考别人的代码(基于Python 2.x写的教程),去利用print函数,打印输出内容时,结果却遇到print函数的语法错误:

SyntaxError: invalid syntax

比如,虽然找个例子的截图为:

【原因】

这是因为,你正在用的Python版本是Python 3.x,而参考别人的代码是Python 2.x的代码,而由于Python 2.x升级到Python 3.x,print函数的语法变化了,

所以你用Python 2.x的print函数的代码,放在Python 3.x中运行,结果就出现了print函数的“SyntaxError: invalid syntax”了。

即,这也是Python初学者,第一个最容易遇到的问题:

在安装了(最新版本的)Python 3.x后,去运行(参考了别人的)Python 2.x的print函数的代码,结果就是遇到了print函数的语法错误:SyntaxError: invalid syntax

【Python 2.x和Python 3.x中print函数语法方面的区别】

最简洁的解释为:

Python 2.x: print函数(所要打印的内容)不带括号

Python 3.x: print函数(所要打印的内容),必须带括号

举例来说明,即为:

1.不带百分号格式化的

python 2.x:

?

1

print “Pyhon 2 can use print string without ()”;

python 3.x:

?

1

print(“Python3, print must use () to output string”);

2. 带百分号格式化的

Python 2.x:

?

1

print “old %s version is %d, print no ()”%(“Python”, 2);

Python 3.x:

?

1

print(“new %s version is %d, print must have ()”%(“Python”, 3));

版权声明:本文内容由互联网用户自发贡献,该文观点仅代表作者本人。本站仅提供信息存储空间服务,不拥有所有权,不承担相关法律责任。如发现本站有涉嫌侵权/违法违规的内容, 请发送邮件至 举报,一经查实,本站将立刻删除。
转载请注明出处: https://daima100.com/23375.html

(0)
上一篇 2023-10-31 11:30
下一篇 2023-10-31

相关推荐

  • 关于首次利用servlet调用数据库时会产生的一些问题[亲测有效]

    关于首次利用servlet调用数据库时会产生的一些问题[亲测有效] 首先声明一点就是,这时正常的java加上web的技术的结合,没有使用maven工程和框架。正常的网页访问是直接启动tomcat就可以了,但是调用一些动态资源或者实现一些后端功能都要用到ser…

    2023-03-28
    97
  • MySql笔记(一)

    MySql笔记(一)每天给自己一个希望,努力做好自己,不为明天烦恼,不为昨天叹息。当梦想还在,告诉自己:努力,就总能遇见更好的自己! [toc] MySql笔记(一) 1、创建数据库以及删除 1.创建数据库语法:(命令行

    2023-01-23
    93
  • clickhouse分区查询_clickhouse架构

    clickhouse分区查询_clickhouse架构一、CK 分布式表和本地表 (1)CK是一个纯列式存储的数据库,一个列就是硬盘上的一个或多个文件(多个分区有多个文件),关于列式存储这里就不展开了,总之列存对于分析来讲好处更大,因为每个列单独存储,所

    2023-05-07
    104
  • Python List 0 – 程序中的未赋值列表

    Python List 0 – 程序中的未赋值列表Python中的列表是非常强大的数据类型之一。不仅能存储多个值,还能够进行大量的操作和处理。在Python中,我们可以使用“[]”来表示一个列表并在里面添加元素。但是,当我们希望创建一个空列表时,我们需要使用未赋值列表。未赋值列表是Python的一个独特特性,它为我们提供了更好的灵活性,在程序中的应用非常广泛。

    2023-12-30
    52
  • 提高代码效率的超实用小技巧,让你的Python sleep clock更智能化

    提高代码效率的超实用小技巧,让你的Python sleep clock更智能化a href=”https://www.python100.com/a/sm.html”font color=”red”免责声明/font/a a href=”https://beian.miit.gov.cn/”苏ICP备2023018380号-1/a Copyright www.python100.com .Some Rights Reserved.

    2024-01-31
    44
  • 每日一道SQL题 – Lu「建议收藏」

    每日一道SQL题 – Lu「建议收藏」说明: 作者:原文出处 答案基于mysql 8.0,自己写的,不一定正确。 20210604 题目: 两张表: id 是自动递增的主键,CandidateId 是 T0604A 表中的 id. 请编写

    2023-04-16
    97
  • 【赵强老师】什么是Redis Cluster

    【赵强老师】什么是Redis Cluster(一)什么是Redis Cluster? Redis Cluster是Redis的分布式解决方案,在Redis 3.0版本正式推出的,有效解决了Redis分布式方面的需求。当遇到单机内存、并发、流量等

    2023-02-15
    95
  • mysql整体迁移_anaconda环境迁移

    mysql整体迁移_anaconda环境迁移一次生产环境mysql迁移操作(一)数据归档 一次生产环境mysql迁移操作(二)mysql空间释放(碎片整理) 背景 在项目过程中我们经常要对数据库进行迁移、归档、拆分等等操作,现在描述下几种方案…

    2023-01-25
    105

发表回复

您的电子邮箱地址不会被公开。 必填项已用*标注